# SoVertexProperty Class Reference
[Nodes]

`#include <Inventor/nodes/SoVertexProperty.h>`

Inheritance diagram for SoVertexProperty:

List of all members.

## Detailed Description

The SoVertexProperty class collects the functionality of various appearance nodes.

Instead of reading data from the current state stack of the scenegraph traversal, nodes inheriting SoVertexShape can be set up with an SoVertexProprty node in the SoVertexShape::vertexProperty field. Coordinates, normals, texture coordinates and material / color information will then be fetched from the vertexshape's SoVertexProperty node instead of from the state stack.

The SoVertexProperty node provides fields for duplicating the functionality of all these other Inventor node types: SoCoordinate3, SoTextureCoordinate2, SoTextureCoordinate3, SoNormal, SoPackedColor, SoMaterialBinding and SoNormalBinding.

The SoVertexProperty node was introduced fairly late in the design of the Inventor API by SGI. The idea behind it was to provide a means to specify the necessary data for vertexshape-derived nodes which would be more efficient to work with than fetching the data from the traversal state stack.

In practice, the effect is not at all very noticable. Since the use of SoVertexProperty nodes in the SoVertexShape::vertexProperty field somewhat breaks with the basic design of the Open Inventor API (the SoVertexProperty data is not pushed to the traversal state stack), you might be better off design-wise by using the usual mechanisms, ie by setting up the individual nodes SoVertexProperty "collects".

One of the drawbacks will for instance be that it's not possible to share parts of the SoVertexProperty node between several shapes, which is something that can easily be done when setting up individual state-changing nodes in the scenegraph.

Since:
  Inventor 2.1

See also:
  SoVertexShape

  SoCoordinate3, SoTextureCoordinate2, SoTextureCoordinate3, SoNormal

  SoPackedColor

  SoMaterialBinding, SoNormalBinding

## Public Types

enum | Binding { OVERALL = 2, PER_PART, PER_PART_INDEXED, PER_FACE, PER_FACE_INDEXED, PER_VERTEX, PER_VERTEX_INDEXED }

## Public Member Functions

| SoVertexProperty (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFVec3f | vertex
SoMFVec2f | texCoord
SoMFVec3f | texCoord3
SoMFVec3f | normal
SoSFEnum | normalBinding
SoMFUInt32 | orderedRGBA
SoSFEnum | materialBinding

## Protected Member Functions

virtual | ~SoVertexProperty ()
virtual void | notify (SoNotList *list)

## Member Enumeration Documentation

enum SoVertexProperty::Binding

| The binding types available for our SoVertexProperty::normalBinding and SoVertexProperty::materialBinding fields. For a detailed explanation of each of the enumeration value binding types, see the documentation of the SoMaterialBinding node.

## Constructor & Destructor Documentation

SoVertexProperty::SoVertexProperty | ( | void |  | ) |

| Constructor.

SoVertexProperty::~SoVertexProperty | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVertexProperty::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoVertexProperty::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoVertexProperty::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoVertexProperty::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoNode.

void SoVertexProperty::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoVertexProperty::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoVertexProperty::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

void SoVertexProperty::notify | ( | SoNotList * | list | ) | `[protected, virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode.

## Member Data Documentation

SoMFVec3f SoVertexProperty::vertex

This field sets up vertex coordinates in the same manner as SoCoordinate3::point.

By default the field contains no coordinates.

See also:
  SoCoordinate3

SoMFVec2f SoVertexProperty::texCoord

Same functionality as SoTextureCoordinate2::point. By default the field contains no coordinates.

See also:
  SoTextureCoordinate2

SoMFVec3f SoVertexProperty::texCoord3

Same functionality as SoTextureCoordinate3::point. By default the field contains no coordinates.

See also:
  SoTextureCoordinate3

Since:
  Coin 2.0

  TGS Inventor 2.6

SoMFVec3f SoVertexProperty::normal

This field defines a set of normal vectors in the same manner as SoNormal::vector. By default the field contains no vectors.

See also:
  SoNormal

SoSFEnum SoVertexProperty::normalBinding

Defines how to bind the normals specified in the SoVertexProperty::normal set to the parts of the "owner" shape. Must be one of the values in the SoVertexProperty::Binding enum.

Default value of the field is SoVertexProperty::PER_VERTEX_INDEXED.

See also:
  SoNormalBinding

SoMFUInt32 SoVertexProperty::orderedRGBA

A set of "packed" 32-bit diffusecolor plus transparency values. Works in the same manner as the SoPackedColor::orderedRGBA field.

By default the field has no data.

See also:
  SoPackedColor

SoSFEnum SoVertexProperty::materialBinding

Defines how to bind the colorvalues specified in the SoVertexProperty::orderedRGBA set to the parts of the "owner" shape. Must be one of the values in the SoVertexProperty::Binding enum.

Default value of the field is SoVertexProperty::OVERALL.

See also:
  SoMaterialBinding

The documentation for this class was generated from the following files:

- SoVertexProperty.h
- SoVertexProperty.cpp